# Class RGBImageFilter

java.lang.Object
java.awt.image.ImageFilter
java.awt.image.RGBImageFilter

All Implemented Interfaces:
  `ImageConsumer, Cloneable`

Direct Known Subclasses:
  `GrayFilter`

public abstract class RGBImageFilter extends ImageFilter
This class provides an easy way to create an ImageFilter which modifies the pixels of an image in the default RGB ColorModel. It is meant to be used in conjunction with a FilteredImageSource object to produce filtered versions of existing images. It is an abstract class that provides the calls needed to channel all of the pixel data through a single method which converts pixels one at a time in the default RGB ColorModel regardless of the ColorModel being used by the ImageProducer. The only method which needs to be defined to create a usable image filter is the filterRGB method. Here is an example of a definition of a filter which swaps the red and blue components of an image:

         class RedBlueSwapFilter extends RGBImageFilter {
             public RedBlueSwapFilter() {
                 // The filter's operation does not depend on the
                 // pixel's location, so IndexColorModels can be
                 // filtered directly.
                 canFilterIndexColorModel = true;
             }

             public int filterRGB(int x, int y, int rgb) {
                 return ((rgb & 0xff00ff00)
                         | ((rgb & 0xff0000) >> 16)
                         | ((rgb & 0xff) << 16));
             }
         }

See Also:
  - `FilteredImageSource`
  - `ImageFilter`
  - `ColorModel.getRGBdefault()`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`canFilterIndexColorModel`
This boolean indicates whether or not it is acceptable to apply the color filtering of the filterRGB method to the color table entries of an IndexColorModel object in lieu of pixel by pixel filtering.
`protected ColorModel`
`newmodel`
The `ColorModel` with which to replace `origmodel` when the user calls `substituteColorModel`.
`protected ColorModel`
`origmodel`
The `ColorModel` to be replaced by `newmodel` when the user calls `substituteColorModel`.

### Fields declared in class ImageFilter

`consumer`
Modifier and Type
Field
Description
`protected ImageConsumer`
`consumer`
The consumer of the particular image data stream for which this instance of the ImageFilter is filtering data.

### Fields declared in interface ImageConsumer

`COMPLETESCANLINES, IMAGEABORTED, IMAGEERROR, RANDOMPIXELORDER, SINGLEFRAME, SINGLEFRAMEDONE, SINGLEPASS, STATICIMAGEDONE, TOPDOWNLEFTRIGHT`
Modifier and Type
Field
Description
`static final int`
`COMPLETESCANLINES`
The pixels will be delivered in (multiples of) complete scanlines at a time.
`static final int`
`IMAGEABORTED`
The image creation process was deliberately aborted.
`static final int`
`IMAGEERROR`
An error was encountered while producing the image.
`static final int`
`RANDOMPIXELORDER`
The pixels will be delivered in a random order.
`static final int`
`SINGLEFRAME`
The image contain a single static image.
`static final int`
`SINGLEFRAMEDONE`
One frame of the image is complete but there are more frames to be delivered.
`static final int`
`SINGLEPASS`
The pixels will be delivered in a single pass.
`static final int`
`STATICIMAGEDONE`
The image is complete and there are no more pixels or frames to be delivered.
`static final int`
`TOPDOWNLEFTRIGHT`
The pixels will be delivered in top-down, left-to-right order.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`RGBImageFilter()`
Constructor for subclasses to call.

## Method Summary

Modifier and Type
Method
Description
`IndexColorModel`
`filterIndexColorModel(IndexColorModel icm)`
Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide.
`abstract int`
`filterRGB(int x, int y, int rgb)`
Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.
`void`
`filterRGBPixels(int x, int y, int w, int h, int[] pixels, int off, int scansize)`
Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.
`void`
`setColorModel(ColorModel model)`
If the ColorModel is an IndexColorModel and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods.
`void`
`setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)`
If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel.
`void`
`setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)`
If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.
`void`
`substituteColorModel(ColorModel oldcm, ColorModel newcm)`
Registers two ColorModel objects for substitution.

### Methods declared in class ImageFilter

`clone, getFilterInstance, imageComplete, resendTopDownLeftRight, setDimensions, setHints, setProperties`
Modifier and Type
Method
Description
`Object`
`clone()`
Clones this object.
`ImageFilter`
`getFilterInstance(ImageConsumer ic)`
Returns a unique instance of an ImageFilter object which will actually perform the filtering for the specified ImageConsumer.
`void`
`imageComplete(int status)`
Filters the information provided in the imageComplete method of the ImageConsumer interface.
`void`
`resendTopDownLeftRight(ImageProducer ip)`
Responds to a request for a TopDownLeftRight (TDLR) ordered resend of the pixel data from an `ImageConsumer`.
`void`
`setDimensions(int width, int height)`
Filters the information provided in the setDimensions method of the ImageConsumer interface.
`void`
`setHints(int hints)`
Filters the information provided in the setHints method of the ImageConsumer interface.
`void`
`setProperties(Hashtable<?,?> props)`
Passes the properties from the source object along after adding a property indicating the stream of filters it has been run through.

### Methods declared in class Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### origmodel

protected ColorModel origmodel
The `ColorModel` to be replaced by `newmodel` when the user calls `substituteColorModel`.

### newmodel

protected ColorModel newmodel
The `ColorModel` with which to replace `origmodel` when the user calls `substituteColorModel`.

### canFilterIndexColorModel

protected boolean canFilterIndexColorModel
This boolean indicates whether or not it is acceptable to apply the color filtering of the filterRGB method to the color table entries of an IndexColorModel object in lieu of pixel by pixel filtering. Subclasses should set this variable to true in their constructor if their filterRGB method does not depend on the coordinate of the pixel being filtered.

See Also:
  - `substituteColorModel(ColorModel, ColorModel)`
  - `filterRGB(int, int, int)`
  - `IndexColorModel`

## Constructor Details

### RGBImageFilter

protected RGBImageFilter()
Constructor for subclasses to call.

## Method Details

### setColorModel

public void setColorModel(ColorModel model)
If the ColorModel is an IndexColorModel and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods. If the ColorModel is not an IndexColorModel or is null, this method overrides the default ColorModel used by the ImageProducer and specifies the default RGB ColorModel instead.

Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

Specified by:
  `setColorModel` in interface `ImageConsumer`
Overrides:
  `setColorModel` in class `ImageFilter`
Parameters:
  `model` - the specified `ColorModel`
See Also:
  - `ImageConsumer`
  - `ColorModel.getRGBdefault()`

### substituteColorModel

public void substituteColorModel(ColorModel oldcm, ColorModel newcm)
Registers two ColorModel objects for substitution. If the oldcm is encountered during any of the setPixels methods, the newcm is substituted and the pixels passed through untouched (but with the new ColorModel object).

Parameters:
  `oldcm` - the ColorModel object to be replaced on the fly
  `newcm` - the ColorModel object to replace oldcm on the fly

### filterIndexColorModel

public IndexColorModel filterIndexColorModel(IndexColorModel icm)
Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide. Uses coordinates of -1 to indicate that a color table entry is being filtered rather than an actual pixel value.

Parameters:
  `icm` - the IndexColorModel object to be filtered
Returns:
  a new IndexColorModel representing the filtered colors
Throws:
  `NullPointerException` - if `icm` is null

### filterRGBPixels

public void filterRGBPixels(int x, int y, int w, int h, int[] pixels, int off, int scansize)
Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.

Parameters:
  `x` - the X coordinate of the upper-left corner of the region of pixels
  `y` - the Y coordinate of the upper-left corner of the region of pixels
  `w` - the width of the region of pixels
  `h` - the height of the region of pixels
  `pixels` - the array of pixels
  `off` - the offset into the `pixels` array
  `scansize` - the distance from one row of pixels to the next in the array
See Also:
  - `ColorModel.getRGBdefault()`
  - `filterRGB(int, int, int)`

### setPixels

public void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)
If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel. Otherwise converts the buffer of byte pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.

Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

Specified by:
  `setPixels` in interface `ImageConsumer`
Overrides:
  `setPixels` in class `ImageFilter`
Parameters:
  `x` - the X coordinate of the upper-left corner of the area of pixels to be set
  `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
  `w` - the width of the area of pixels
  `h` - the height of the area of pixels
  `model` - the specified `ColorModel`
  `pixels` - the array of pixels
  `off` - the offset into the `pixels` array
  `scansize` - the distance from one row of pixels to the next in the `pixels` array
See Also:
  - `ColorModel.getRGBdefault()`
  - `filterRGBPixels(int, int, int, int, int[], int, int)`

### setPixels

public void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)
If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one. Converts a buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method.

Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

Specified by:
  `setPixels` in interface `ImageConsumer`
Overrides:
  `setPixels` in class `ImageFilter`
Parameters:
  `x` - the X coordinate of the upper-left corner of the area of pixels to be set
  `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
  `w` - the width of the area of pixels
  `h` - the height of the area of pixels
  `model` - the specified `ColorModel`
  `pixels` - the array of pixels
  `off` - the offset into the `pixels` array
  `scansize` - the distance from one row of pixels to the next in the `pixels` array
See Also:
  - `ColorModel.getRGBdefault()`
  - `filterRGBPixels(int, int, int, int, int[], int, int)`

### filterRGB

public abstract int filterRGB(int x, int y, int rgb)
Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.

Parameters:
  `x` - the X coordinate of the pixel
  `y` - the Y coordinate of the pixel
  `rgb` - the integer pixel representation in the default RGB color model
Returns:
  a filtered pixel in the default RGB color model.
See Also:
  - `ColorModel.getRGBdefault()`
  - `filterRGBPixels(int, int, int, int, int[], int, int)`